/**
 * Digitaluhr
 */
public class Uhr extends Ereignisbehandlung
{
    private Nummernanzeige minuten;
    private Nummernanzeige sekunden;
    
    private Text anzeige;

    /**
     * Konstruktor
     */
    public Uhr()
    {
        super();
        minuten =  new  Nummernanzeige(60);
        sekunden =  new  Nummernanzeige(60);
        
        //Darstellung
        anzeige = new Text();
        anzeige.PositionSetzen(100,100);
        anzeige.TextGrößeSetzen(40);
        anzeige.TextSetzen(AnzeigeAusgeben());
    }

    /**
     * Erstellt aus den Zeitbestandteilen eine Anzeige als Zeichenkette
     * @return Anzeige als Zeichenkette
     */
    public String AnzeigeAusgeben()
    {
        String gesamtAnzeige;
        gesamtAnzeige = ZweistelligeZahlAlsTextErstellen(minuten.WertGeben()) + ":" + ZweistelligeZahlAlsTextErstellen(sekunden.WertGeben());
        return gesamtAnzeige;
    }

    /**
     * Wandelt eine ein- oder zweistellige Zahl in einen String mit 2 Zeichen um
     * @param zahl die umzuwandelnde Zahl
     * @return die zugehörige Zeichenkette
     */
    public String ZweistelligeZahlAlsTextErstellen(int zahl)
    {
        if (zahl < 10)
        {
            return "0" + zahl;
        }
        else
        {
            return "" + zahl;
        }
    }

    /**
     * Schaltet die Uhr um eine Sekunde weiter
     */
    @Override public void TaktImpulsAusführen()
    {
        sekunden.Erhöhen();
        if (sekunden.WertGeben() == 0)
        {
            minuten.Erhöhen();
        }
        anzeige.TextSetzen(AnzeigeAusgeben());
    }
}
