
/**
 * Klasse zur Beschreibung eines Buttons
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
public class Button extends Ereignisbehandlung
{
    /** x-Position */
    private int x;
    /** y-Position */
    private int y;
    /** Breite des Button */
    private int breite;
    /** Rechteck zur Darstellung des Buttons */
    private Rechteck rahmen;
    /** Textfeld zur Beschriftung des Buttons */
    private Text text;
    /** Farbe des Buttons */
    private String farbe;

    /**
     * Konstruktor des Buttons
     */
    public Button()
    {
        x = 50;
        y = 50;
        breite = 70;

        farbe = "rot";
        rahmen = new Rechteck();
        rahmen.GrößeSetzen(70, 20);
        rahmen.PositionSetzen(x, y);
        rahmen.FarbeSetzen(farbe);

        text = new Text();
        text.PositionSetzen(x + 5, y + 12);
        text.TextSetzen("Klick mich");

    }

    /**
     * Ereignisroutine des Mausklicks
     * @param xKlick x-Position des Mausklicks
     * @param yKlick y-Position des Mausklicks
     * @param anzahl Anzahl der Klicks
     */
    @Override public void MausGeklickt(int xKlick, int yKlick, int anzahl)
    {
        if(xKlick >= x && xKlick <=x + breite && yKlick > y && yKlick < y + 20)
        {
            AufMausklickReagieren();
        }

    }

    /**
     * Farbe des Buttons setzen
     * @param farbeNeu Farbe 
     */
    public void FarbeSetzen(String farbeNeu)
    {
        rahmen.FarbeSetzen(farbeNeu);
    }

    /**
     * Beschriftung des Buttons setzen
     * @param textNeu Text
     */
    public void TextSetzen(String textNeu)
    {
        text.TextSetzen(textNeu);
    }

    /**
     * Position des Buttons setzen
     * @param xNeu neue x-Koordinate
     * @param yNeu neue y-Koordinate
     */
    public void PositionSetzen(int xNeu, int yNeu)
    {
        x = xNeu;
        y = yNeu;
        rahmen.PositionSetzen(x, y);
        text.PositionSetzen(x + 5, y + 12);
    }

    /**
     * Methode definiert die Reaktion, falls der Button angeklickt wurde.
     * Methode bei Bedarf überschreiben!
     */
    protected void AufMausklickReagieren()
    {
        if(farbe == "rot")
        {
            farbe = "grün";
        }
        else
        {
            farbe = "rot";
        }
        FarbeSetzen(farbe);
    }
}

