
import java.awt.event.*;
import java.util.*;
/**
 * Rahmenklasse des Spiels
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Spiel extends EreignisBehandlung
{
    /** Die Schlange.*/
    Schlange schlange;
    /** Das Spielfeld.*/
    RandSymbol spielfeldrand;
    /** Der Punktestand */
    int punkte;
    /** Zufallsgeneror für das Spiel */
    Random zzGenerator;
    
    /**
     * Baut die Basiselemente auf.
     */
    Spiel()
    {
        char richtung;
        int xStart, yStart;
        zzGenerator = new Random();
        switch (zzGenerator.nextInt(4))
        {
            case 0:
                richtung = 'O';
                break;
            case 1:
                richtung = 'N';
                break;
            case 2:
                richtung = 'W';
                break;
            default:
                richtung = 'S';
                break;
        }
        xStart = -5 + zzGenerator.nextInt(10);
        yStart = -4 + zzGenerator.nextInt(8);
        schlange = new Schlange(xStart, yStart, richtung);
        spielfeldrand = new RandSymbol();
        punkte = 0;
        TaktdauerSetzen(500);
    }

    /**
     * Bewegt die Schlange.
     */
    @Override void TaktImpulsAusführen()
    {
        if ((schlange.XPositionGeben() <= spielfeldrand.XMaxGeben()) && (schlange.XPositionGeben() >= spielfeldrand.XMinGeben()) &&
            (schlange.YPositionGeben() <= spielfeldrand.YMaxGeben()) && (schlange.YPositionGeben() >= spielfeldrand.YMinGeben()) &&
            ! schlange.KopfInRumpf())
        {
            schlange.Bewegen();
            punkte += 1;
            spielfeldrand.PunkteSetzen(punkte);
        }
        else
        {
            Anhalten();
            if (schlange.KopfInRumpf())
            {
                spielfeldrand.EndemeldungSetzen("Game Over - Schlange hat sich selbst gebissen");
            }
            else
            {
                spielfeldrand.EndemeldungSetzen("Game Over - Schlange über Spielfeldrand");
            }
        }
    }
    
    /**
     * Wertet die Tasteneingaben aus.
     * @param welche Tastencode
     */
    @Override void TasteGedrückt(char welche)
    {
        switch (welche)
        {
          case 'S':
          case 's':
            Starten();
            break;
          case 'P':
          case 'p':
            Anhalten();
            break;
          case KeyEvent.VK_DOWN:
          case KeyEvent.VK_KP_DOWN:
            schlange.RichtungSetzen('S');
            break;
          case KeyEvent.VK_LEFT:
            schlange.RichtungSetzen('W');
            break;
          case KeyEvent.VK_RIGHT:
            schlange.RichtungSetzen('O');
            break;
          case KeyEvent.VK_UP:
            schlange.RichtungSetzen('N');
            break;
          default:
            //System.out.println("Taste: " + (0 + (int) welche));
        }
    }
}
