
/**
 * Verwaltung des Hauses
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class Haus
{
    private HintergrundSymbol hintergrund;
    private Thermometer thermometerEsszimmer;
    private HeizkoerperSymbol heizkörperSymbolEsszimmer;
    private Heizkoerper heizkörperEsszimmer;

    /**
     * Legt die Sensoren und Komponenten des Hauses an
     */
    Haus()
    {
        hintergrund = new HintergrundSymbol();
        thermometerEsszimmer = new Thermometer("Esszimmer");
        heizkörperSymbolEsszimmer = new HeizkoerperSymbol(420, 440);
        heizkörperEsszimmer = new Heizkoerper("Esszimmer", heizkörperSymbolEsszimmer, thermometerEsszimmer);
    }
    
    /**
     * Setzt das Thermometer im Esszimmer auf einen neuen Wert
     * @param eingabe neuer Temperaturwert
     */
    void ThermometerEsszimmerWertSetzen (int eingabe)
    {
        thermometerEsszimmer.WertSetzen(eingabe);
    }
    
    /**
     * Schaltet den Heizkörper im Esszimmer dauerhaft ein
     */
    void HeizkörperEsszimmerEinschalten()
    {
        heizkörperEsszimmer.Einschalten();
    }
    
    /**
     * Schaltet den Heizkörper im Esszimmer dauerhaft aus
     */
    void HeizkörperEsszimmerAusschalten()
    {
        heizkörperEsszimmer.Ausschalten();
    }
    
    /**
     * Setzt den Heizkörper im Esszimmer auf Automatikbetrieb
     */
    void HeizkörperEsszimmerAutomatikSetzen()
    {
        heizkörperEsszimmer.AutomatikAktivieren();
    }
    
    /**
     * Zeigt die zustände aller Geräte an
     */
    void ZuständeAnzeigen()
    {
        System.out.println(thermometerEsszimmer.name + ": " + thermometerEsszimmer.ZustandGeben());
        System.out.println(heizkörperEsszimmer.name + ": " + heizkörperEsszimmer.ZustandGeben());
    }
}
