import java.util.ArrayList;

/**
 * Darstellung eines Heizkörpers
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
class HeizkoerperSymbol
{   
    private ArrayList<Kreis> innenkreise;
    private ArrayList<Rechteck> innenrechtecke;

	/**
	 * Baut das Symbol auf
	 * @param x x-Koordinate
	 * @param y y-Koordinate
     */
    HeizkoerperSymbol(int x, int y)
    {        
        innenkreise = new ArrayList<Kreis>();
        innenrechtecke = new ArrayList<Rechteck>();
        
        for (int index = 0; index < 8; index = index + 1)
        {
            HeizkörperSegmentAnPos(x + index * 10, y);
        }
    }
    
    /**
	 * Meldet den neuen Zustand an das Symbol
	 * @param an der Heizkörper ist eingeschaltet
     */
    void ÄnderungMelden(boolean an)
    {
        if (an)
        {
            for (Kreis k : innenkreise)
            {
                k.FarbeSetzen("rot");
            }
            
            for (Rechteck r : innenrechtecke)
            {
                r.FarbeSetzen("rot");
            }

        }
        else
        {
            for (Kreis k : innenkreise)
            {
                k.FarbeSetzen("weiß");
            }    
            
            for (Rechteck r : innenrechtecke)
            {
                r.FarbeSetzen("weiß");
            }
        }
    }

	/**
	 * Fügt dem Heizkörper ein neues Segment hinzu
	 * @param x x-Koordinate
	 * @param y y-Koordinate
     */
    private void HeizkörperSegmentAnPos(int x, int y)
    {
        // Segment außen
        Kreis oben = new Kreis();
        oben.RadiusSetzen(10);
        oben.PositionSetzen(x + 10, y + 10);
        oben.FarbeSetzen("schwarz");

        Rechteck mitte = new Rechteck();
        mitte.GrößeSetzen(21, 40);
        mitte.PositionSetzen(x, y + 10);
        mitte.FarbeSetzen("schwarz");

        Kreis unten  = new Kreis();
        unten.RadiusSetzen(10);
        unten.PositionSetzen(x + 10, y + 50);
        unten.FarbeSetzen("schwarz");

        // Segment innen
        Kreis obenInnen = new Kreis();
        obenInnen.RadiusSetzen(8);
        obenInnen.PositionSetzen(x + 10, y + 10);
        obenInnen.FarbeSetzen("weiß");
        innenkreise.add(obenInnen);

        Rechteck mitteInnen = new Rechteck();
        mitteInnen.GrößeSetzen(17, 42);
        mitteInnen.PositionSetzen(x + 2, y + 9);
        mitteInnen.FarbeSetzen("weiß");
        innenrechtecke.add(mitteInnen);

        Kreis untenInnen  = new Kreis();
        untenInnen.RadiusSetzen(8);
        untenInnen.PositionSetzen(x + 10, y + 50);
        untenInnen.FarbeSetzen("weiß");
        innenkreise.add(untenInnen);
    }   

}
