
/**
 * Beschreibt einen Lichtsensor
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Sonnensensor
{
    /** Name des Sensors */
    String name;
    /** aktueller Wert der Messung */
    int aktuellerWert;
    /** Lampe, der Änderungen gemeldet werden */
    Lampe beobachter;

    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Sonnensensor(String namensZusatz)
    {
        name = "Sonnensensor " + namensZusatz;
        beobachter = null;
        aktuellerWert = 0;
    }
    
    /**
     * Registriert einen Beobachter
     * @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    void BeobachterRegistrieren (Lampe beobachter)
    {
        this.beobachter = beobachter;
    }

    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (int eingabe)
    {
        if ((eingabe >= 0) && (eingabe <= 100))
        {
            aktuellerWert = eingabe;
            beobachter.WertänderungMeldenSonnenSensor(aktuellerWert);
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    String ZustandGeben()
    {
        return "" + aktuellerWert + " %";
    }
}
