
/**
 * Beschreibt eine Waage
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Waage
{
    /** Name des Sensors */
    String name;
    /** aktueller Wert der Messung */
    int aktuellerWert;
    /** Kühlschrank, dem Änderungen gemeldet werden */
    Kuehlschrank beobachter;
    
    /**
     * Legt den Namen und den Beobachter fest.
     * @param namensZusatz individualler Namensteil des Sensors
     */
    Waage(String namensZusatz)
    {
        name = "Waage " + namensZusatz;
        beobachter = null;
        aktuellerWert = 0;
    }
    
    /**
     * Registriert einen Beobachter
     * @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    void BeobachterRegistrieren (Kuehlschrank beobachter)
    {
        this.beobachter = beobachter;
    }

    /**
     * Setzt den neuen Sensorwert
     * @param eingabe der neue Sensorwert
     */
    void WertSetzen (int eingabe)
    {
        if ((eingabe >= 0) && (eingabe <= 10000))
        {
            aktuellerWert = eingabe;
            beobachter.WertänderungMelden(aktuellerWert);
        }
    }
    
    /**
     * Meldet den Zustand des Sensors
     * @return Zustand als Zeichenkette
     */
    String ZustandGeben()
    {
        return "" + aktuellerWert + " g";
    }
}
